Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3744)
+++ palm/trunk/SOURCE/Makefile	(revision 3745)
@@ -20,10 +20,13 @@
 # Current revisions:
 # ------------------
-# Add Netcdf data output for indoor model
-# Remove some dependencies
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$
+# Add Netcdf data output for indoor model
+# Remove some dependencies
+# 
+# 3744 2019-02-15 18:38:58Z suehring
 # Enable mesoscale offline nesting for chemistry variables as well as 
 # initialization of chemistry via dynamic input file.
Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3745)
@@ -21,4 +21,9 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
 ! - remove building_type from module
 ! - initialize parameters for each building individually instead of a bulk 
@@ -28,7 +33,5 @@
 ! - some restructuring of variables in building data structure
 ! 
-! Former revisions:
-! -----------------
-! $Id$
+! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3744)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3745)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Add indoor model
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Add indoor model
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! Removed bio_check_parameters as the method is empty.
 ! 
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3745)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Add indoor model
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Add indoor model
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! Bugfix: - initialize return values to ensure they are set before returning
 !           (routine define_geo_coordinates)
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3745)
@@ -22,10 +22,13 @@
 ! Current revisions:
 ! ------------------
-! Bugfix in transpiration, floating invalid when temperature 
-! becomes > 40 degrees
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Bugfix in transpiration, floating invalid when temperature 
+! becomes > 40 degrees
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3745)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Output of waste_heat and innermost wall flux from indoor model
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Output of waste_heat and innermost wall flux from indoor model
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! Add azimuth and zenith to output file; set long-name attributes; 
 ! clean-up coding layout
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3745)
@@ -21,10 +21,13 @@
 ! Current revisions:
 ! ------------------
-! Bugfix, missing calculation of 10cm temperature at vertical building walls, 
-! required for indoor model
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Bugfix, missing calculation of 10cm temperature at vertical building walls, 
+! required for indoor model
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 3745)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! +waste_heat
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! +waste_heat
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! OpenACC port for SPEC
 ! 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3744)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3745)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Call indoor model after first timestep
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Call indoor model after first timestep
+! 
+! 3744 2019-02-15 18:38:58Z suehring
 ! - Moved call of bio_calculate_thermal_index_maps from biometeorology module to
 ! time_integration to make sure averaged input is updated before calculating.
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3744)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3745)
@@ -23,4 +23,9 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
 ! - Remove internal flag indoor_model (is a global control parameter)
 ! - add waste heat from buildings to the kinmatic heat flux
@@ -28,7 +33,5 @@
 ! - remove unused USE statements
 ! 
-! Former revisions:
-! -----------------
-! $Id$
+! 3744 2019-02-15 18:38:58Z suehring
 ! fixed surface heat capacity in the building parameters
 ! convert the file back to unix format